import lime.Assets;
#if !macro


class ApplicationMain {
	
	
	public static var config:lime.app.Config;
	public static var preloader:openfl.display.Preloader;
	
	private static var app:lime.app.Application;
	
	
	public static function create ():Void {
		
		app = new openfl.display.Application ();
		app.create (config);
		
		var display = new flixel.system.FlxPreloader ();
		
		preloader = new openfl.display.Preloader (display);
		preloader.onComplete = init;
		preloader.create (config);
		
		#if js
		var urls = [];
		var types = [];
		
		
		urls.push ("assets/images/arrow.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/bg.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/demo_typecard.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/losescreen.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/losescreen_top.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/losescreen_typecard.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/movieposter.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/movieposter_lights.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/runcycle.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/spacebar.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/theateroverlay.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/tilesheet.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/traincar.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/trainlong.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/trainlong2.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/trainlong_tiny.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/whiteflicker.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/winscreen.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/winscreen_typecard.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/images/winscreen_typecard2.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/music/music.wav");
		types.push (AssetType.SOUND);
		
		
		urls.push ("assets/tiled/demolevel.csv");
		types.push (AssetType.TEXT);
		
		
		urls.push ("assets/tiled/runnerlevel.csv");
		types.push (AssetType.TEXT);
		
		
		urls.push ("assets/tiled/runnerlevel.tmx");
		types.push (AssetType.TEXT);
		
		
		urls.push ("assets/tiled/tiles.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/tiled/tiles2.png");
		types.push (AssetType.IMAGE);
		
		
		urls.push ("assets/sounds/beep.mp3");
		types.push (AssetType.MUSIC);
		
		
		urls.push ("assets/sounds/flixel.mp3");
		types.push (AssetType.MUSIC);
		
		
		
		preloader.load (urls, types);
		#end
		
		var result = app.exec ();
		
		#if sys
		Sys.exit (result);
		#end
		
	}
	
	
	public static function init ():Void {
		
		var loaded = 0;
		var total = 0;
		var library_onLoad = function (_) {
			
			loaded++;
			
			if (loaded == total) {
				
				start ();
				
			}
			
		}
		
		
		
		if (loaded == total) {
			
			start ();
			
		}
		
	}
	
	
	public static function main () {
		
		config = {
			
			antialiasing: Std.int (0),
			background: Std.int (0),
			borderless: false,
			depthBuffer: false,
			fps: Std.int (60),
			fullscreen: false,
			height: Std.int (720),
			orientation: "portrait",
			resizable: true,
			stencilBuffer: false,
			title: "FlxProject",
			vsync: true,
			width: Std.int (1280),
			
		}
		
		#if js
		#if munit
		flash.Lib.embed (null, 1280, 720, "000000");
		#end
		#else
		create ();
		#end
		
	}
	
	
	public static function start ():Void {
		
		openfl.Lib.current.stage.align = openfl.display.StageAlign.TOP_LEFT;
		openfl.Lib.current.stage.scaleMode = openfl.display.StageScaleMode.NO_SCALE;
		
		var hasMain = false;
		
		for (methodName in Type.getClassFields (Main)) {
			
			if (methodName == "main") {
				
				hasMain = true;
				break;
				
			}
			
		}
		
		if (hasMain) {
			
			Reflect.callMethod (Main, Reflect.field (Main, "main"), []);
			
		} else {
			
			var instance:DocumentClass = Type.createInstance (DocumentClass, []);
			
			if (Std.is (instance, openfl.display.DisplayObject)) {
				
				openfl.Lib.current.addChild (cast instance);
				
			}
			
		}
		
		openfl.Lib.current.stage.dispatchEvent (new openfl.events.Event (openfl.events.Event.RESIZE, false, false));
		
	}
	
	
	#if neko
	@:noCompletion public static function __init__ () {
		
		var loader = new neko.vm.Loader (untyped $loader);
		loader.addPath (haxe.io.Path.directory (Sys.executablePath ()));
		loader.addPath ("./");
		loader.addPath ("@executable_path/");
		
	}
	#end
	
	
}


#if flash @:build(DocumentClass.buildFlash())
#else @:build(DocumentClass.build()) #end
@:keep class DocumentClass extends Main {}


#else


import haxe.macro.Context;
import haxe.macro.Expr;


class DocumentClass {
	
	
	macro public static function build ():Array<Field> {
		
		var classType = Context.getLocalClass ().get ();
		var searchTypes = classType;
		
		while (searchTypes.superClass != null) {
			
			if (searchTypes.pack.length == 2 && searchTypes.pack[1] == "display" && searchTypes.name == "DisplayObject") {
				
				var fields = Context.getBuildFields ();
				
				var method = macro {
					
					this.stage = flash.Lib.current.stage;
					super ();
					dispatchEvent (new openfl.events.Event (openfl.events.Event.ADDED_TO_STAGE, false, false));
					
				}
				
				fields.push ({ name: "new", access: [ APublic ], kind: FFun({ args: [], expr: method, params: [], ret: macro :Void }), pos: Context.currentPos () });
				
				return fields;
				
			}
			
			searchTypes = searchTypes.superClass.t.get ();
			
		}
		
		return null;
		
	}
	
	
	macro public static function buildFlash ():Array<Field> {
		
		var classType = Context.getLocalClass ().get ();
		var searchTypes = classType;
		
		while (searchTypes.superClass != null) {
			
			if (searchTypes.pack.length == 2 && searchTypes.pack[1] == "display" && searchTypes.name == "DisplayObject") {
				
				var fields = Context.getBuildFields ();
				var method = macro {
					return flash.Lib.current.stage;
				}
				
				fields.push ({ name: "get_stage", access: [ APrivate ], meta: [ { name: ":getter", params: [ macro stage ], pos: Context.currentPos() } ], kind: FFun({ args: [], expr: method, params: [], ret: macro :flash.display.Stage }), pos: Context.currentPos() });
				return fields;
				
			}
			
			searchTypes = searchTypes.superClass.t.get ();
			
		}
		
		return null;
		
	}
	
	
}


#end