package;


import haxe.Timer;
import haxe.Unserializer;
import lime.app.Preloader;
import lime.audio.openal.AL;
import lime.audio.AudioBuffer;
import lime.graphics.Font;
import lime.graphics.Image;
import lime.utils.ByteArray;
import lime.utils.UInt8Array;
import lime.Assets;

#if sys
import sys.FileSystem;
#end

#if flash
import flash.display.Bitmap;
import flash.display.BitmapData;
import flash.display.Loader;
import flash.events.Event;
import flash.media.Sound;
import flash.net.URLLoader;
import flash.net.URLRequest;
#end


class DefaultAssetLibrary extends AssetLibrary {
	
	
	public var className (default, null) = new Map <String, Dynamic> ();
	public var path (default, null) = new Map <String, String> ();
	public var type (default, null) = new Map <String, AssetType> ();
	
	private var lastModified:Float;
	private var timer:Timer;
	
	
	public function new () {
		
		super ();
		
		#if flash
		
		className.set ("assets/images/arrow.png", __ASSET__assets_images_arrow_png);
		type.set ("assets/images/arrow.png", AssetType.IMAGE);
		className.set ("assets/images/bg.png", __ASSET__assets_images_bg_png);
		type.set ("assets/images/bg.png", AssetType.IMAGE);
		className.set ("assets/images/demo_typecard.png", __ASSET__assets_images_demo_typecard_png);
		type.set ("assets/images/demo_typecard.png", AssetType.IMAGE);
		className.set ("assets/images/losescreen.png", __ASSET__assets_images_losescreen_png);
		type.set ("assets/images/losescreen.png", AssetType.IMAGE);
		className.set ("assets/images/losescreen_top.png", __ASSET__assets_images_losescreen_top_png);
		type.set ("assets/images/losescreen_top.png", AssetType.IMAGE);
		className.set ("assets/images/losescreen_typecard.png", __ASSET__assets_images_losescreen_typecard_png);
		type.set ("assets/images/losescreen_typecard.png", AssetType.IMAGE);
		className.set ("assets/images/movieposter.png", __ASSET__assets_images_movieposter_png);
		type.set ("assets/images/movieposter.png", AssetType.IMAGE);
		className.set ("assets/images/movieposter_lights.png", __ASSET__assets_images_movieposter_lights_png);
		type.set ("assets/images/movieposter_lights.png", AssetType.IMAGE);
		className.set ("assets/images/runcycle.png", __ASSET__assets_images_runcycle_png);
		type.set ("assets/images/runcycle.png", AssetType.IMAGE);
		className.set ("assets/images/spacebar.png", __ASSET__assets_images_spacebar_png);
		type.set ("assets/images/spacebar.png", AssetType.IMAGE);
		className.set ("assets/images/theateroverlay.png", __ASSET__assets_images_theateroverlay_png);
		type.set ("assets/images/theateroverlay.png", AssetType.IMAGE);
		className.set ("assets/images/tilesheet.png", __ASSET__assets_images_tilesheet_png);
		type.set ("assets/images/tilesheet.png", AssetType.IMAGE);
		className.set ("assets/images/traincar.png", __ASSET__assets_images_traincar_png);
		type.set ("assets/images/traincar.png", AssetType.IMAGE);
		className.set ("assets/images/trainlong.png", __ASSET__assets_images_trainlong_png);
		type.set ("assets/images/trainlong.png", AssetType.IMAGE);
		className.set ("assets/images/trainlong2.png", __ASSET__assets_images_trainlong2_png);
		type.set ("assets/images/trainlong2.png", AssetType.IMAGE);
		className.set ("assets/images/trainlong_tiny.png", __ASSET__assets_images_trainlong_tiny_png);
		type.set ("assets/images/trainlong_tiny.png", AssetType.IMAGE);
		className.set ("assets/images/whiteflicker.png", __ASSET__assets_images_whiteflicker_png);
		type.set ("assets/images/whiteflicker.png", AssetType.IMAGE);
		className.set ("assets/images/winscreen.png", __ASSET__assets_images_winscreen_png);
		type.set ("assets/images/winscreen.png", AssetType.IMAGE);
		className.set ("assets/images/winscreen_typecard.png", __ASSET__assets_images_winscreen_typecard_png);
		type.set ("assets/images/winscreen_typecard.png", AssetType.IMAGE);
		className.set ("assets/images/winscreen_typecard2.png", __ASSET__assets_images_winscreen_typecard2_png);
		type.set ("assets/images/winscreen_typecard2.png", AssetType.IMAGE);
		className.set ("assets/music/music.wav", __ASSET__assets_music_music_wav);
		type.set ("assets/music/music.wav", AssetType.SOUND);
		className.set ("assets/tiled/demolevel.csv", __ASSET__assets_tiled_demolevel_csv);
		type.set ("assets/tiled/demolevel.csv", AssetType.TEXT);
		className.set ("assets/tiled/runnerlevel.csv", __ASSET__assets_tiled_runnerlevel_csv);
		type.set ("assets/tiled/runnerlevel.csv", AssetType.TEXT);
		className.set ("assets/tiled/runnerlevel.tmx", __ASSET__assets_tiled_runnerlevel_tmx);
		type.set ("assets/tiled/runnerlevel.tmx", AssetType.TEXT);
		className.set ("assets/tiled/tiles.png", __ASSET__assets_tiled_tiles_png);
		type.set ("assets/tiled/tiles.png", AssetType.IMAGE);
		className.set ("assets/tiled/tiles2.png", __ASSET__assets_tiled_tiles2_png);
		type.set ("assets/tiled/tiles2.png", AssetType.IMAGE);
		className.set ("assets/sounds/beep.mp3", __ASSET__assets_sounds_beep_mp3);
		type.set ("assets/sounds/beep.mp3", AssetType.MUSIC);
		className.set ("assets/sounds/flixel.mp3", __ASSET__assets_sounds_flixel_mp3);
		type.set ("assets/sounds/flixel.mp3", AssetType.MUSIC);
		
		
		#elseif html5
		
		var id;
		id = "assets/images/arrow.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/bg.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/demo_typecard.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/losescreen.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/losescreen_top.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/losescreen_typecard.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/movieposter.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/movieposter_lights.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/runcycle.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/spacebar.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/theateroverlay.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/tilesheet.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/traincar.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/trainlong.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/trainlong2.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/trainlong_tiny.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/whiteflicker.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/winscreen.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/winscreen_typecard.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/images/winscreen_typecard2.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/music/music.wav";
		path.set (id, id);
		
		type.set (id, AssetType.SOUND);
		id = "assets/tiled/demolevel.csv";
		path.set (id, id);
		
		type.set (id, AssetType.TEXT);
		id = "assets/tiled/runnerlevel.csv";
		path.set (id, id);
		
		type.set (id, AssetType.TEXT);
		id = "assets/tiled/runnerlevel.tmx";
		path.set (id, id);
		
		type.set (id, AssetType.TEXT);
		id = "assets/tiled/tiles.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/tiled/tiles2.png";
		path.set (id, id);
		
		type.set (id, AssetType.IMAGE);
		id = "assets/sounds/beep.mp3";
		path.set (id, id);
		
		type.set (id, AssetType.MUSIC);
		id = "assets/sounds/flixel.mp3";
		path.set (id, id);
		
		type.set (id, AssetType.MUSIC);
		
		
		#else
		
		#if openfl
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		#end
		
		#if (windows || mac || linux)
		
		/*var useManifest = false;
		
		className.set ("assets/images/arrow.png", __ASSET__assets_images_arrow_png);
		type.set ("assets/images/arrow.png", AssetType.IMAGE);
		
		className.set ("assets/images/bg.png", __ASSET__assets_images_bg_png);
		type.set ("assets/images/bg.png", AssetType.IMAGE);
		
		className.set ("assets/images/demo_typecard.png", __ASSET__assets_images_demo_typecard_png);
		type.set ("assets/images/demo_typecard.png", AssetType.IMAGE);
		
		className.set ("assets/images/losescreen.png", __ASSET__assets_images_losescreen_png);
		type.set ("assets/images/losescreen.png", AssetType.IMAGE);
		
		className.set ("assets/images/losescreen_top.png", __ASSET__assets_images_losescreen_top_png);
		type.set ("assets/images/losescreen_top.png", AssetType.IMAGE);
		
		className.set ("assets/images/losescreen_typecard.png", __ASSET__assets_images_losescreen_typecard_png);
		type.set ("assets/images/losescreen_typecard.png", AssetType.IMAGE);
		
		className.set ("assets/images/movieposter.png", __ASSET__assets_images_movieposter_png);
		type.set ("assets/images/movieposter.png", AssetType.IMAGE);
		
		className.set ("assets/images/movieposter_lights.png", __ASSET__assets_images_movieposter_lights_png);
		type.set ("assets/images/movieposter_lights.png", AssetType.IMAGE);
		
		className.set ("assets/images/runcycle.png", __ASSET__assets_images_runcycle_png);
		type.set ("assets/images/runcycle.png", AssetType.IMAGE);
		
		className.set ("assets/images/spacebar.png", __ASSET__assets_images_spacebar_png);
		type.set ("assets/images/spacebar.png", AssetType.IMAGE);
		
		className.set ("assets/images/theateroverlay.png", __ASSET__assets_images_theateroverlay_png);
		type.set ("assets/images/theateroverlay.png", AssetType.IMAGE);
		
		className.set ("assets/images/tilesheet.png", __ASSET__assets_images_tilesheet_png);
		type.set ("assets/images/tilesheet.png", AssetType.IMAGE);
		
		className.set ("assets/images/traincar.png", __ASSET__assets_images_traincar_png);
		type.set ("assets/images/traincar.png", AssetType.IMAGE);
		
		className.set ("assets/images/trainlong.png", __ASSET__assets_images_trainlong_png);
		type.set ("assets/images/trainlong.png", AssetType.IMAGE);
		
		className.set ("assets/images/trainlong2.png", __ASSET__assets_images_trainlong2_png);
		type.set ("assets/images/trainlong2.png", AssetType.IMAGE);
		
		className.set ("assets/images/trainlong_tiny.png", __ASSET__assets_images_trainlong_tiny_png);
		type.set ("assets/images/trainlong_tiny.png", AssetType.IMAGE);
		
		className.set ("assets/images/whiteflicker.png", __ASSET__assets_images_whiteflicker_png);
		type.set ("assets/images/whiteflicker.png", AssetType.IMAGE);
		
		className.set ("assets/images/winscreen.png", __ASSET__assets_images_winscreen_png);
		type.set ("assets/images/winscreen.png", AssetType.IMAGE);
		
		className.set ("assets/images/winscreen_typecard.png", __ASSET__assets_images_winscreen_typecard_png);
		type.set ("assets/images/winscreen_typecard.png", AssetType.IMAGE);
		
		className.set ("assets/images/winscreen_typecard2.png", __ASSET__assets_images_winscreen_typecard2_png);
		type.set ("assets/images/winscreen_typecard2.png", AssetType.IMAGE);
		
		className.set ("assets/music/music.wav", __ASSET__assets_music_music_wav);
		type.set ("assets/music/music.wav", AssetType.SOUND);
		
		className.set ("assets/tiled/demolevel.csv", __ASSET__assets_tiled_demolevel_csv);
		type.set ("assets/tiled/demolevel.csv", AssetType.TEXT);
		
		className.set ("assets/tiled/runnerlevel.csv", __ASSET__assets_tiled_runnerlevel_csv);
		type.set ("assets/tiled/runnerlevel.csv", AssetType.TEXT);
		
		className.set ("assets/tiled/runnerlevel.tmx", __ASSET__assets_tiled_runnerlevel_tmx);
		type.set ("assets/tiled/runnerlevel.tmx", AssetType.TEXT);
		
		className.set ("assets/tiled/tiles.png", __ASSET__assets_tiled_tiles_png);
		type.set ("assets/tiled/tiles.png", AssetType.IMAGE);
		
		className.set ("assets/tiled/tiles2.png", __ASSET__assets_tiled_tiles2_png);
		type.set ("assets/tiled/tiles2.png", AssetType.IMAGE);
		
		className.set ("assets/sounds/beep.mp3", __ASSET__assets_sounds_beep_mp3);
		type.set ("assets/sounds/beep.mp3", AssetType.MUSIC);
		
		className.set ("assets/sounds/flixel.mp3", __ASSET__assets_sounds_flixel_mp3);
		type.set ("assets/sounds/flixel.mp3", AssetType.MUSIC);
		*/
		var useManifest = true;
		
		if (useManifest) {
			
			loadManifest ();
			
			if (Sys.args ().indexOf ("-livereload") > -1) {
				
				var path = FileSystem.fullPath ("manifest");
				lastModified = FileSystem.stat (path).mtime.getTime ();
				
				timer = new Timer (2000);
				timer.run = function () {
					
					var modified = FileSystem.stat (path).mtime.getTime ();
					
					if (modified > lastModified) {
						
						lastModified = modified;
						loadManifest ();
						
						if (eventCallback != null) {
							
							eventCallback (this, "change");
							
						}
						
					}
					
				}
				
			}
			
		}
		
		#else
		
		loadManifest ();
		
		#end
		#end
		
	}
	
	
	public override function exists (id:String, type:String):Bool {
		
		var requestedType = type != null ? cast (type, AssetType) : null;
		var assetType = this.type.get (id);
		
		if (assetType != null) {
			
			if (assetType == requestedType || ((requestedType == SOUND || requestedType == MUSIC) && (assetType == MUSIC || assetType == SOUND))) {
				
				return true;
				
			}
			
			#if flash
			
			if ((assetType == BINARY || assetType == TEXT) && requestedType == BINARY) {
				
				return true;
				
			} else if (path.exists (id)) {
				
				return true;
				
			}
			
			#else
			
			if (requestedType == BINARY || requestedType == null || (assetType == BINARY && requestedType == TEXT)) {
				
				return true;
				
			}
			
			#end
			
		}
		
		return false;
		
	}
	
	
	public override function getAudioBuffer (id:String):AudioBuffer {
		
		#if flash
		
		var buffer = new AudioBuffer ();
		buffer.src = cast (Type.createInstance (className.get (id), []), Sound);
		return buffer;
		
		#elseif js
		
		return null;
		//return new Sound (new URLRequest (path.get (id)));
		
		#else
		
		return AudioBuffer.fromFile (path.get (id));
		//if (className.exists(id)) return cast (Type.createInstance (className.get (id), []), Sound);
		//else return new Sound (new URLRequest (path.get (id)), null, type.get (id) == MUSIC);
		
		#end
		
	}
	
	
	public override function getBytes (id:String):ByteArray {
		
		#if flash
		
		return cast (Type.createInstance (className.get (id), []), ByteArray);
		
		#elseif js
		
		var bytes:ByteArray = null;
		var data = Preloader.loaders.get (path.get (id)).data;
		
		if (Std.is (data, String)) {
			
			bytes = new ByteArray ();
			bytes.writeUTFBytes (data);
			
		} else if (Std.is (data, ByteArray)) {
			
			bytes = cast data;
			
		} else {
			
			bytes = null;
			
		}
		
		if (bytes != null) {
			
			bytes.position = 0;
			return bytes;
			
		} else {
			
			return null;
		}
		
		#else
		
		//return null;
		//if (className.exists(id)) return cast (Type.createInstance (className.get (id), []), ByteArray);
		//else 
		return ByteArray.readFile (path.get (id));
		
		#end
		
	}
	
	
	public override function getFont (id:String):Dynamic /*Font*/ {
		
		// TODO: Complete Lime Font API
		
		#if openfl
		#if (flash || js)
		
		return cast (Type.createInstance (className.get (id), []), openfl.text.Font);
		
		#else
		
		if (className.exists (id)) {
			
			var fontClass = className.get (id);
			openfl.text.Font.registerFont (fontClass);
			return cast (Type.createInstance (fontClass, []), openfl.text.Font);
			
		} else {
			
			return new openfl.text.Font (path.get (id));
			
		}
		
		#end
		#end
		
		return null;
		
	}
	
	
	public override function getImage (id:String):Image {
		
		#if flash
		
		return Image.fromBitmapData (cast (Type.createInstance (className.get (id), []), BitmapData));
		
		#elseif js
		
		return Image.fromImageElement (Preloader.images.get (path.get (id)));
		
		#else
		
		return Image.fromFile (path.get (id));
		
		#end
		
	}
	
	
	/*public override function getMusic (id:String):Dynamic {
		
		#if flash
		
		return cast (Type.createInstance (className.get (id), []), Sound);
		
		#elseif openfl_html5
		
		//var sound = new Sound ();
		//sound.__buffer = true;
		//sound.load (new URLRequest (path.get (id)));
		//return sound;
		return null;
		
		#elseif js
		
		return null;
		//return new Sound (new URLRequest (path.get (id)));
		
		#else
		
		return null;
		//if (className.exists(id)) return cast (Type.createInstance (className.get (id), []), Sound);
		//else return new Sound (new URLRequest (path.get (id)), null, true);
		
		#end
		
	}*/
	
	
	public override function getPath (id:String):String {
		
		//#if ios
		
		//return SystemPath.applicationDirectory + "/assets/" + path.get (id);
		
		//#else
		
		return path.get (id);
		
		//#end
		
	}
	
	
	public override function getText (id:String):String {
		
		#if js
		
		var bytes:ByteArray = null;
		var data = Preloader.loaders.get (path.get (id)).data;
		
		if (Std.is (data, String)) {
			
			return cast data;
			
		} else if (Std.is (data, ByteArray)) {
			
			bytes = cast data;
			
		} else {
			
			bytes = null;
			
		}
		
		if (bytes != null) {
			
			bytes.position = 0;
			return bytes.readUTFBytes (bytes.length);
			
		} else {
			
			return null;
		}
		
		#else
		
		var bytes = getBytes (id);
		
		if (bytes == null) {
			
			return null;
			
		} else {
			
			return bytes.readUTFBytes (bytes.length);
			
		}
		
		#end
		
	}
	
	
	public override function isLocal (id:String, type:String):Bool {
		
		var requestedType = type != null ? cast (type, AssetType) : null;
		
		#if flash
		
		if (requestedType != AssetType.MUSIC && requestedType != AssetType.SOUND) {
			
			return className.exists (id);
			
		}
		
		#end
		
		return true;
		
	}
	
	
	public override function list (type:String):Array<String> {
		
		var requestedType = type != null ? cast (type, AssetType) : null;
		var items = [];
		
		for (id in this.type.keys ()) {
			
			if (requestedType == null || exists (id, type)) {
				
				items.push (id);
				
			}
			
		}
		
		return items;
		
	}
	
	
	public override function loadAudioBuffer (id:String, handler:AudioBuffer -> Void):Void {
		
		#if (flash || js)
		
		//if (path.exists (id)) {
			
		//	var loader = new Loader ();
		//	loader.contentLoaderInfo.addEventListener (Event.COMPLETE, function (event) {
				
		//		handler (cast (event.currentTarget.content, Bitmap).bitmapData);
				
		//	});
		//	loader.load (new URLRequest (path.get (id)));
			
		//} else {
			
			handler (getAudioBuffer (id));
			
		//}
		
		#else
		
		handler (getAudioBuffer (id));
		
		#end
		
	}
	
	
	public override function loadBytes (id:String, handler:ByteArray -> Void):Void {
		
		#if flash
		
		if (path.exists (id)) {
			
			var loader = new URLLoader ();
			loader.addEventListener (Event.COMPLETE, function (event:Event) {
				
				var bytes = new ByteArray ();
				bytes.writeUTFBytes (event.currentTarget.data);
				bytes.position = 0;
				
				handler (bytes);
				
			});
			loader.load (new URLRequest (path.get (id)));
			
		} else {
			
			handler (getBytes (id));
			
		}
		
		#else
		
		handler (getBytes (id));
		
		#end
		
	}
	
	
	public override function loadImage (id:String, handler:Image -> Void):Void {
		
		#if flash
		
		if (path.exists (id)) {
			
			var loader = new Loader ();
			loader.contentLoaderInfo.addEventListener (Event.COMPLETE, function (event:Event) {
				
				var bitmapData = cast (event.currentTarget.content, Bitmap).bitmapData;
				handler (Image.fromBitmapData (bitmapData));
				
			});
			loader.load (new URLRequest (path.get (id)));
			
		} else {
			
			handler (getImage (id));
			
		}
		
		#else
		
		handler (getImage (id));
		
		#end
		
	}
	
	
	#if (!flash && !html5)
	private function loadManifest ():Void {
		
		try {
			
			#if blackberry
			var bytes = ByteArray.readFile ("app/native/manifest");
			#elseif tizen
			var bytes = ByteArray.readFile ("../res/manifest");
			#elseif emscripten
			var bytes = ByteArray.readFile ("assets/manifest");
			#else
			var bytes = ByteArray.readFile ("manifest");
			#end
			
			if (bytes != null) {
				
				bytes.position = 0;
				
				if (bytes.length > 0) {
					
					var data = bytes.readUTFBytes (bytes.length);
					
					if (data != null && data.length > 0) {
						
						var manifest:Array<Dynamic> = Unserializer.run (data);
						
						for (asset in manifest) {
							
							if (!className.exists (asset.id)) {
								
								path.set (asset.id, asset.path);
								type.set (asset.id, cast (asset.type, AssetType));
								
							}
							
						}
						
					}
					
				}
				
			} else {
				
				trace ("Warning: Could not load asset manifest (bytes was null)");
				
			}
		
		} catch (e:Dynamic) {
			
			trace ('Warning: Could not load asset manifest (${e})');
			
		}
		
	}
	#end
	
	
	/*public override function loadMusic (id:String, handler:Dynamic -> Void):Void {
		
		#if (flash || js)
		
		//if (path.exists (id)) {
			
		//	var loader = new Loader ();
		//	loader.contentLoaderInfo.addEventListener (Event.COMPLETE, function (event) {
				
		//		handler (cast (event.currentTarget.content, Bitmap).bitmapData);
				
		//	});
		//	loader.load (new URLRequest (path.get (id)));
			
		//} else {
			
			handler (getMusic (id));
			
		//}
		
		#else
		
		handler (getMusic (id));
		
		#end
		
	}*/
	
	
	public override function loadText (id:String, handler:String -> Void):Void {
		
		//#if js
		
		/*if (path.exists (id)) {
			
			var loader = new URLLoader ();
			loader.addEventListener (Event.COMPLETE, function (event:Event) {
				
				handler (event.currentTarget.data);
				
			});
			loader.load (new URLRequest (path.get (id)));
			
		} else {
			
			handler (getText (id));
			
		}*/
		
		//#else
		
		var callback = function (bytes:ByteArray):Void {
			
			if (bytes == null) {
				
				handler (null);
				
			} else {
				
				handler (bytes.readUTFBytes (bytes.length));
				
			}
			
		}
		
		loadBytes (id, callback);
		
		//#end
		
	}
	
	
}


#if !display
#if flash

@:keep @:bind #if display private #end class __ASSET__assets_images_arrow_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_bg_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_demo_typecard_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_losescreen_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_losescreen_top_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_losescreen_typecard_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_movieposter_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_movieposter_lights_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_runcycle_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_spacebar_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_theateroverlay_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_tilesheet_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_traincar_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_trainlong_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_trainlong2_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_trainlong_tiny_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_whiteflicker_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_winscreen_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_winscreen_typecard_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_images_winscreen_typecard2_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_music_music_wav extends flash.media.Sound { }
@:keep @:bind #if display private #end class __ASSET__assets_tiled_demolevel_csv extends flash.utils.ByteArray { }
@:keep @:bind #if display private #end class __ASSET__assets_tiled_runnerlevel_csv extends flash.utils.ByteArray { }
@:keep @:bind #if display private #end class __ASSET__assets_tiled_runnerlevel_tmx extends flash.utils.ByteArray { }
@:keep @:bind #if display private #end class __ASSET__assets_tiled_tiles_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_tiled_tiles2_png extends flash.display.BitmapData { public function new () { super (0, 0, true, 0); } }
@:keep @:bind #if display private #end class __ASSET__assets_sounds_beep_mp3 extends flash.media.Sound { }
@:keep @:bind #if display private #end class __ASSET__assets_sounds_flixel_mp3 extends flash.media.Sound { }


#elseif html5

#if openfl





























#end

#else

#if openfl

#end

#if (windows || mac || linux)

//
//@:bitmap("assets/images/arrow.png") class __ASSET__assets_images_arrow_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/bg.png") class __ASSET__assets_images_bg_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/demo_typecard.png") class __ASSET__assets_images_demo_typecard_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/losescreen.png") class __ASSET__assets_images_losescreen_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/losescreen_top.png") class __ASSET__assets_images_losescreen_top_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/losescreen_typecard.png") class __ASSET__assets_images_losescreen_typecard_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/movieposter.png") class __ASSET__assets_images_movieposter_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/movieposter_lights.png") class __ASSET__assets_images_movieposter_lights_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/runcycle.png") class __ASSET__assets_images_runcycle_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/spacebar.png") class __ASSET__assets_images_spacebar_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/theateroverlay.png") class __ASSET__assets_images_theateroverlay_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/tilesheet.png") class __ASSET__assets_images_tilesheet_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/traincar.png") class __ASSET__assets_images_traincar_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/trainlong.png") class __ASSET__assets_images_trainlong_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/trainlong2.png") class __ASSET__assets_images_trainlong2_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/trainlong_tiny.png") class __ASSET__assets_images_trainlong_tiny_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/whiteflicker.png") class __ASSET__assets_images_whiteflicker_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/winscreen.png") class __ASSET__assets_images_winscreen_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/winscreen_typecard.png") class __ASSET__assets_images_winscreen_typecard_png extends openfl.display.BitmapData {}
//@:bitmap("assets/images/winscreen_typecard2.png") class __ASSET__assets_images_winscreen_typecard2_png extends openfl.display.BitmapData {}
//@:sound("assets/music/music.wav") class __ASSET__assets_music_music_wav extends openfl.media.Sound {}
//@:file("assets/tiled/demolevel.csv") class __ASSET__assets_tiled_demolevel_csv extends lime.utils.ByteArray {}
//@:file("assets/tiled/runnerlevel.csv") class __ASSET__assets_tiled_runnerlevel_csv extends lime.utils.ByteArray {}
//@:file("assets/tiled/runnerlevel.tmx") class __ASSET__assets_tiled_runnerlevel_tmx extends lime.utils.ByteArray {}
//@:bitmap("assets/tiled/tiles.png") class __ASSET__assets_tiled_tiles_png extends openfl.display.BitmapData {}
//@:bitmap("assets/tiled/tiles2.png") class __ASSET__assets_tiled_tiles2_png extends openfl.display.BitmapData {}
//@:sound("/usr/lib/haxe/lib/flixel/3,3,6/assets/sounds/beep.mp3") class __ASSET__assets_sounds_beep_mp3 extends openfl.media.Sound {}
//@:sound("/usr/lib/haxe/lib/flixel/3,3,6/assets/sounds/flixel.mp3") class __ASSET__assets_sounds_flixel_mp3 extends openfl.media.Sound {}
//
//

#end

#end
#end

