package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.FlxObject;
import flixel.tile.FlxTilemap;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
import flixel.FlxCamera;
import flixel.group.FlxGroup;
import flixel.util.FlxTimer;
import openfl.Assets;
using flixel.util.FlxSpriteUtil;

/**
* Introduces players to the game + controls
*/
class DemoState extends FlxState

{
	public var _player:Player;
	public var _traincar:TrainCar;
	public var _train:TrainLong;	
	public var level:FlxTilemap;
	public var player:FlxSprite;



	/**
	 * Function that is called up when to state is created to set it up. 
	 */
	override public function create():Void
	{
		var trk:FlxSprite = new FlxSprite(0,0);
		trk.loadGraphic("assets/images/bg.png", true, 640, 360);
		trk.scrollFactor.x = trk.scrollFactor.y = 0;
		add(trk);

		addLevel();



		_traincar = new TrainCar(360,180);
		add (_traincar);
		_train = new TrainLong(-652,180);
		add (_train);

		setCamera();

		_player = new Player(100,180);
		add(_player);
		_player._playerspeed == 90;

		var w:FlxSprite = new FlxSprite(0,0);
		w.loadGraphic("assets/images/theateroverlay.png", true, 640, 360);
		w.scrollFactor.x = w.scrollFactor.y = 0;
		add(w);

		var sb2:FlxSprite = new FlxSprite(270,70);
		sb2.loadGraphic("assets/images/spacebar.png", true, 100, 100);
		sb2.animation.add("blip", [0,0,1,0,1,0], 4, true);
		sb2.scrollFactor.x = sb2.scrollFactor.y = 0;
		add(sb2);
		sb2.animation.play("blip");

		super.create();
	}

	function addLevel():Void
	{
		level = new FlxTilemap();
		level.loadMap(Assets.getText("assets/tiled/demolevel.csv"), "assets/tiled/tiles2.png", 16, 16);
		for (i in 7...18) level.setTileProperties(i, FlxObject.NONE);


		add(level);

	}

	//function addLevel():Void
	//{
	//	level = new TiledLevel();
	//	level.loadMap("assets/data/tilemap.txt", "assets/images/tiles.png", 16, 16);
	//	add(level);
	//}
	
	/**
	 * Function that is called when this state is destroyed - you might want to 
	 * consider setting all objects this state uses to null to help garbage collection.
	 */


	override public function destroy():Void
	{
		super.destroy();
	}


	function setCamera():Void
	{
		FlxG.camera.follow(_traincar, FlxCamera.STYLE_PLATFORMER, 100);
		FlxG.camera.setBounds(0, 0, level.width, level.height, true);
	}

	/**
	 * Function that is called once every frame.
	 */
	override public function update():Void
	{
	FlxG.collide(level, _player);
	playTheDamnGame();

		super.update();
	}	

	private function playTheDamnGame():Void
	{
		if (_player.velocity.x > 90)
		{
		FlxG.switchState(new PlayState());
		}
	}
}