package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
using flixel.util.FlxSpriteUtil;
import flixel.util.FlxDestroyUtil;



/**
 * A FlxState which can be used for the game's menu.
 */
class MenuState extends FlxState
{
	//private var _btnPlay:FlxButton;	
	/**
	 * Function that is called up when to state is created to set it up. 
	 */
	override public function create():Void
	{
		//_btnPlay = new FlxButton(0,0, "Play", clickPlay);
		//_btnPlay.screenCenter(true,true);
		//add(_btnPlay);
		FlxG.sound.playMusic("assets/music/music.wav", 1, true);

		var mp:FlxSprite = new FlxSprite(0,0);
		mp.loadGraphic("assets/images/movieposter.png", true, 640, 360);
		add(mp);

		var mpl:FlxSprite = new FlxSprite(0,0);
		mpl.loadGraphic("assets/images/movieposter_lights.png", true, 280, 360);
		mpl.animation.add("flashinglights", [0,1], 4, true);
		add(mpl);
		mpl.animation.play("flashinglights");



		var sb:FlxSprite = new FlxSprite(410,210);
		sb.loadGraphic("assets/images/spacebar.png", true, 100, 100);
		sb.animation.add("blip", [0,0,1,0,1,0], 4, true);
		add(sb);
		sb.animation.play("blip");

		FlxG.camera.flash(0xFF000000, 3);

		//_creditsbutton = new FlxButton(0, 0, "Label", myCallback);
		//myButton.loadGraphic("assets/custom.png");

		super.create();

	}

	private function spaceToPlay():Void
	{
		if (FlxG.keys.justPressed.SPACE)
		{
			FlxG.switchState(new IntroState());
		}
	}
	
	/**
	 * Function that is called when this state is destroyed - you might want to 
	 * consider setting all objects this state uses to null to help garbage collection.
	 */
	override public function destroy():Void
	{
		//sb = FlxDestroyUtil.destroy(sb);
		super.destroy();
	}

	/**
	 * Function that is called once every frame.
	 */
	override public function update():Void
	{
		spaceToPlay();

		super.update();
	}	

}