package;

import flixel.FlxG;
import flixel.FlxSprite;
import flixel.FlxState;
import flixel.FlxObject;
import flixel.tile.FlxTilemap;
import flixel.text.FlxText;
import flixel.ui.FlxButton;
import flixel.util.FlxMath;
import flixel.FlxCamera;
import flixel.group.FlxGroup;
import flixel.util.FlxTimer;
import openfl.Assets;


/**
 * A FlxState which can be used for the actual gameplay.
 */
class PlayState extends FlxState

{
	public var _player:Player;
	public var _traincar:TrainCar;
	public var _train:TrainLong;
	public var _exit:FlxSprite;
	public var _goingoffscreen:StupidHitbox;
	public var level:FlxTilemap;
	public var player:FlxSprite;


	/**
	 * Function that is called up when to state is created to set it up. 
	 */
	override public function create():Void
	{

		var trk:FlxSprite = new FlxSprite(0,0);
		trk.loadGraphic("assets/images/bg.png", true, 640, 360);
		trk.scrollFactor.x = trk.scrollFactor.y = 0;
		add(trk);


		_exit = new FlxSprite(3790, 150);
		_exit.makeGraphic(10, 64, 0xFFFF0000);
		add(_exit);

		_traincar = new TrainCar(380,180);
		add (_traincar);
		_train = new TrainLong(-630,180);
		add (_train);

		var arrow:FlxSprite = new FlxSprite(375,120);
		arrow.loadGraphic("assets/images/arrow.png", true, 34, 44);
		arrow.animation.add("blinkyblinky", [0,0,0,0,0,1,1,2,2,1,1,2,2,0], 4, false);
		arrow.animation.play("blinkyblinky");	
		arrow.velocity.x = 90;
		add(arrow);

		addLevel();

		_player = new Player(180,130);
		add(_player);

		_goingoffscreen = new StupidHitbox(-100,150);
		add (_goingoffscreen);




		setCamera();



		var flicker:FlxSprite = new FlxSprite(0,0);
		flicker.loadGraphic("assets/images/whiteflicker.png", true, 640, 360);
		flicker.scrollFactor.x = flicker.scrollFactor.y = 0;
		//flicker.alpha=.75;
		flicker.animation.add("flashyflashy", [1,0,1,1,0,1,0], 12, false);
		flicker.animation.play("flashyflashy");		
		add(flicker);

		var w:FlxSprite = new FlxSprite(0,0);
		w.loadGraphic("assets/images/theateroverlay.png", true, 640, 360);
		w.scrollFactor.x = w.scrollFactor.y = 0;
		add(w);


		super.create();
	}

	function addLevel():Void
	{
		level = new FlxTilemap();
		level.loadMap(Assets.getText("assets/tiled/runnerlevel.csv"), "assets/tiled/tiles.png", 16, 16);
		for (i in 8...19) level.setTileProperties(i, FlxObject.NONE);
		for (i in 0...2) level.setTileProperties(i, FlxObject.NONE);


		add(level);
	}

	//function addLevel():Void
	//{
	//	level = new TiledLevel();
	//	level.loadMap("assets/data/tilemap.txt", "assets/images/tiles.png", 16, 16);
	//	add(level);
	//}
	
	/**
	 * Function that is called when this state is destroyed - you might want to 
	 * consider setting all objects this state uses to null to help garbage collection.
	 */



	override public function destroy():Void
	{
		super.destroy();
	}


	function setCamera():Void
	{
		FlxG.camera.follow(_traincar, FlxCamera.STYLE_PLATFORMER, 100);
		FlxG.camera.setBounds(0, 0, level.width, level.height, true);
	}


	function winGame(e:FlxSprite, p:Player):Void
	{
		if (!p.hasWon) {
			p.velocity.x = 0;
			p.acceleration.x = 0;
			//p.animation.play("check");
			p.hasWon = true;
			FlxG.switchState(new WinState());
		}
	}

	public function leaveStageLose(?t:FlxTimer):Void
	{
		FlxG.switchState(new LoseState());

	}


	function loseGame(FlxSprite, FlxSprite):Void
	{
		_player._playerspeed = 0;
		//new FlxTimer(1, leaveStageLose);
		leaveStageLose();

	}

	/**
	 * Function that is called once every frame.
	 */
	override public function update():Void
	{
	//checkPlayerOnScreen();	
	FlxG.collide(level, _player);

	FlxG.overlap(_traincar, _player, winGame);
	FlxG.overlap(_traincar, _exit, loseGame);
	FlxG.collide(_goingoffscreen, _player, loseGame);



		super.update();
	}	
}